/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package Entity;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.Size;

/**
 *
 * @author asus
 */
@Entity
@Table(name = "booking")
@NamedQueries({
    @NamedQuery(name = "Booking.findAll", query = "SELECT b FROM Booking b"),
    @NamedQuery(name = "Booking.findByBookingid", query = "SELECT b FROM Booking b WHERE b.bookingid = :bookingid"),
    @NamedQuery(name = "Booking.findBySource", query = "SELECT b FROM Booking b WHERE b.source = :source"),
    @NamedQuery(name = "Booking.findByDestination", query = "SELECT b FROM Booking b WHERE b.destination = :destination"),
    @NamedQuery(name = "Booking.findByBookingtime", query = "SELECT b FROM Booking b WHERE b.bookingtime = :bookingtime"),
    @NamedQuery(name = "Booking.findByStartridetime", query = "SELECT b FROM Booking b WHERE b.startridetime = :startridetime"),
    @NamedQuery(name = "Booking.findByEndridetime", query = "SELECT b FROM Booking b WHERE b.endridetime = :endridetime")})
public class Booking implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "bookingid")
    private Integer bookingid;
    @Size(max = 100)
    @Column(name = "source")
    private String source;
    @Size(max = 100)
    @Column(name = "destination")
    private String destination;
    @Column(name = "bookingtime")
    @Temporal(TemporalType.TIMESTAMP)
    private Date bookingtime;
    @Column(name = "startridetime")
    @Temporal(TemporalType.TIMESTAMP)
    private Date startridetime;
    @Column(name = "endridetime")
    @Temporal(TemporalType.TIMESTAMP)
    private Date endridetime;
    @JoinColumn(name = "cab_id", referencedColumnName = "cab_id")
    @ManyToOne(optional = false)
    private Cab cabId;
    @JoinColumn(name = "customerid", referencedColumnName = "customerid")
    @ManyToOne(optional = false)
    private Customer customerid;

    public Booking() {
    }

    public Booking(Integer bookingid) {
        this.bookingid = bookingid;
    }

    public Integer getBookingid() {
        return bookingid;
    }

    public void setBookingid(Integer bookingid) {
        this.bookingid = bookingid;
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    public String getDestination() {
        return destination;
    }

    public void setDestination(String destination) {
        this.destination = destination;
    }

    public Date getBookingtime() {
        return bookingtime;
    }

    public void setBookingtime(Date bookingtime) {
        this.bookingtime = bookingtime;
    }

    public Date getStartridetime() {
        return startridetime;
    }

    public void setStartridetime(Date startridetime) {
        this.startridetime = startridetime;
    }

    public Date getEndridetime() {
        return endridetime;
    }

    public void setEndridetime(Date endridetime) {
        this.endridetime = endridetime;
    }

    public Cab getCabId() {
        return cabId;
    }

    public void setCabId(Cab cabId) {
        this.cabId = cabId;
    }

    public Customer getCustomerid() {
        return customerid;
    }

    public void setCustomerid(Customer customerid) {
        this.customerid = customerid;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (bookingid != null ? bookingid.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Booking)) {
            return false;
        }
        Booking other = (Booking) object;
        if ((this.bookingid == null && other.bookingid != null) || (this.bookingid != null && !this.bookingid.equals(other.bookingid))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "Entity.Booking[ bookingid=" + bookingid + " ]";
    }
    
}
